#ifndef P4ErrorCodes_h
#define P4ErrorCodes_h

// This should all be replaced with something that will auto-generate
// enums for the error codes

static const int kP4ErrorNoSuchFile    = 554768759; // when running an fstat

static const int kP4ErrorCannotConnect = 824577037; // could not connect to server
static const int kP4ErrorTimeout        = 857800705; // operation times out
static const int kP4ErrorInvalidPassword = 807672853; // when running anything
static const int kP4ErrorTicketExpired = 805379379; // when running anything
static const int kP4ErrorLoginNeeded = 805379394; // when running anything
static const int kP4FileNotRecognized = 554768759; // No file record in Perforce

extern const int kP4ErrorConnect;

extern NSString * const P4MEErrorDomain;

enum eP4MEErrorCode
{
    kP4MEErrorCodeInvalidUser = 1
    , kP4MEErrorCodeBadTempDir
    , kP4MESpecDefinitionNotFound
    , kP4MESpecDefinitionRefreshError
};


extern NSString * const kP4MEErrorP4PortKey;
extern NSString * const kP4MEErrorUserKey;
extern NSString * const kP4MEErrorClientKey;
extern NSString * const kP4MEErrorUnderlyingErrorsKey;


extern NSString * const P4ServerConnectionReceivedErrorNotification;
extern NSString * const kP4ServerConnectionReceivedErrorNotificationResponseKey;
extern NSString * const kP4ServerConnectionReceivedErrorNotificationContextKey;
extern NSString * const kP4ServerConnectionReceivedErrorNotificationArgumentsKey;

#ifdef __cplusplus
extern "C" {
#endif
    
BOOL IsConnectionError( NSError * e );

#ifdef __cplusplus
};
#endif



#endif // P4ErrorCodes_h
